*! mpml_wt Version 1.1  Dan_Blanchette@unc.edu  & Kim Chantala 29Apr2011  
*! the carolina population center, unc-ch
** - made it handle missing values for 
** mpml_wt Version 1.0  Dan_Blanchette@unc.edu  & Kim Chantala 12Oct2005  

program mpml_wt, nclass 
	version 8     
	syntax [if] [in], psu_id(varlist) fsu_id(varlist) psu_wt(varname numeric) ///
                          fsu_wt(varname numeric) ///
			[ mpml_wta(name) summ ]
                        // mean_wt(name) n_sample(name) f_wt_std(name)  ]

	marksample touse, novarlist
	quietly count  if `touse'
		if r(N) == 0 error 2000
	

        if "`mpml_wta'" == ""  local mpml_wta = "mpml_wta"
/***
        if "`f_wt_std'" == ""  local f_wt_std = "f_wt_std"
        if "`mean_wt'"  == ""  local mean_wt  = "mean_wt"
        if "`n_sample'" == ""  local n_sample = "n_sample"
***/


	capture confirm name `mpml_wta'
	if _rc != 0  local badvars "`mpml_wta'"
/***
	capture confirm name `f_wt_std'
	if _rc != 0  local badvars "`f_wt_std'"
	capture confirm name `mean_wt'
	if _rc != 0  local badvars "`badvars' `mean_wt'"
	capture confirm name `n_sample'
	if _rc != 0  local badvars "`badvars' `n_sample'"
***/
        tempvar f_wt_std mean_wt n_sample

	if "`badvars'" != ""  {
		di as error "These variables are created in this program so either drop them or rename them: " 
		di as text "`badvars'"
		di as result "{stata drop `badvars':click here} to drop `badvars'"
		exit 198
	}
	
        foreach wt of varlist `psu_wt' `fsu_wt' {
                quietly count  if `wt' == 0
                if r(N) > 0 {
                        di as error _n "WARNING: Your sample weight `wt' contains zero values." _n
                }
        }




	quietly {

		egen double `mean_wt' = mean(`fsu_wt')  if `touse' == 1,  by(`psu_id')
	
		egen double `n_sample' = count(`fsu_wt')  if `touse' == 1,  by(`psu_id')
	
		label var `n_sample'    "Number of `fsu_id' in `psu_id'" 
	

		gen double `f_wt_std' = `fsu_wt' / `mean_wt'  if `touse'
		label var `f_wt_std' "Standardized Within-PSU (`fsu_wt' / `psu_wt') level 1 weight"
	
		gen double `mpml_wta' = `f_wt_std' * `psu_wt'  if `touse'
		label var `mpml_wta' "2-level Scaled ML Sampling weight, method A"
		
	}

        if "`summ'" != "" {	
	  su `psu_wt' `fsu_wt' `f_wt_std' `mpml_wta' `mean_wt' `n_sample'
          di as res "`mean_wt' is mean_wt"
          di as res "`n_sample' is n_sample"
        }
end
